package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientPayerException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientWithInvoicesException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.AgencyWithReservationsException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class AgencyListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new AgencyCreator();
	}
	
	public SaveAdapter getUpdater() {
		return new AgencyUpdater();
	}
	
	public Vector load() {
		Vector list = new Vector();

		try {
			list = AgencyController.agencyList();
		} catch (InternalErrorException e) {}

		return list;
	}
	
	public void delete(Serializable id) {

		try {
			AgencyController.deleteAgency((Long) id);
		} catch (InstanceNotFoundException e) {		
		} catch (InternalErrorException e) {
		} catch (AgencyWithReservationsException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (ClientPayerException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (ClientWithInvoicesException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		}

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = AgencyController.findAgency((Long) id);
		} catch (InstanceNotFoundException e) {
        } catch (InternalErrorException e) {}
        return map;
	}
	
	
}
