package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.CancelledReservationException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.FinishedReservationException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnregisteredReservationException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class GroupCheckInListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new CheckInCreator();
	}
	
	public SaveAdapter getUpdater() {
		ErrorsHandler.clear();
		ErrorsHandler.add(new ErrorItem("update"));
		throw new UnsupportedOperationException();
	}
	
	@SuppressWarnings("unchecked")
	public Vector load() {
		
		Vector aux = new Vector();
		Vector list = new Vector();

		try {
			aux = CheckInController.checkInList();
		
			for (int i=0; i < aux.size(); i++) {
			
				if (CheckInController.reservationRequests((Long) ((TextItem) aux.elementAt(i)).getId()).size() > 1) 
					list.add(aux.elementAt(i));
				
			}
			
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}
		
		return list;

	}
	
	public void delete(Serializable id) {
		
		try {
			ErrorsHandler.clear();
			CheckInController.deleteCheckIn((Long) id);
		} catch (InstanceNotFoundException e) {		
			e.printStackTrace();
		} catch (InternalErrorException e) {
			e.printStackTrace();
		} catch (FinishedReservationException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("finishedReservation"));
		} catch (CancelledReservationException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("cancelledReservation"));
		} catch (UnregisteredReservationException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("unregisteredReservation"));
		}
	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = CheckInController.findCheckIn((Long) id);
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
        } catch (InternalErrorException e) {
        	e.printStackTrace();
        }
        return map;
	}
	
}
