package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.RegisteredReservationException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class IndividualReservationListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new ReservationCreator();
	}
	
	public SaveAdapter getUpdater() {
		return new ReservationUpdater();
	}
	
	@SuppressWarnings("unchecked")
	public Vector load() {
		
		Vector aux = new Vector();
		Vector list = new Vector();

		try {
			aux = ReservationController.reservationList();
		
			for (int i=0; i < aux.size(); i++) {
			
				if (ReservationController.reservationRequests((Long) ((TextItem) aux.elementAt(i)).getId()).size() == 1) 
					list.add(aux.elementAt(i));
				
			}
			
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}
		
		return list;

	}
	
	public void delete(Serializable id) {
		
		try {
			ErrorsHandler.clear();
			ReservationController.deleteReservation((Long) id);
		} catch (InstanceNotFoundException e) {		
			e.printStackTrace();
		} catch (RegisteredReservationException e) {			
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}
	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = ReservationController.findReservation((Long) id);
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
        } catch (InternalErrorException e) {
        	e.printStackTrace();
        }
        return map;
	}
	
}

