package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.PriceTypeInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.PriceTypeTariffiedException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Vector;

public class PriceTypeListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new PriceTypeCreator();
	}

	public SaveAdapter getUpdater() {
		return new PriceTypeUpdater();
	}

	public Vector load() {
		Vector list = new Vector();

		try {
			list = PriceTypeController.priceTypeList();
		} catch (InternalErrorException e) {}

		return list;
	}

	public void delete(Serializable id) {

		try {
			PriceTypeController.deletePriceType((String) id);
		} catch (PriceTypeTariffiedException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (PriceTypeInUseException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (InstanceNotFoundException e) {
		} catch (InternalErrorException e) {
		}

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();

		map = PriceTypeController.findPriceType((String) id);

		return map;
	}

}
