package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptableBoardException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.UnaceptablePriceTypeException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableAgencyException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableCompanyException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableParticularException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptablePayerException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableRoomException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnavailableRoomException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InvalidIntervalException;

import java.io.Serializable;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Vector;

public class ReservationUpdater extends SaveAdapter {

	public Serializable save(HashMap map, Vector vector) {

		try {

			if (inputTesting(map))

				ReservationController.updateReservation((Long) map.get("id"), (String) map.get("reservatorName"), (String) map.get("reservatorCif"), (String) map.get("reservatorAccount"), 
						(String) map.get("reservatorCard"), (String) map.get("reservatorPhone"), (String) map.get("reservationStatus"), (Calendar) map.get("incomingDate"), 
						(Calendar) map.get("expectedOutgoingDate"), (Calendar) map.get("trueOutgoingDate"), (Long) map.get("payer"), (Long) map.get("agency"), (Long) map.get("company"), 
						(String) map.get("notes"), ((Boolean) map.get("byHours")).booleanValue(), vector);
			
		} catch (UnaceptableParticularException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("particular"));
		} catch (UnaceptableBoardException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("board"));
		} catch (UnaceptablePriceTypeException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("priceType"));
		} catch (UnaceptableAgencyException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("agency"));
		} catch (UnaceptablePayerException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("payer"));
		} catch (UnaceptableRoomException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("roomUnaceptable"));
		} catch (UnavailableRoomException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("roomUnavailable"));
		} catch (UnaceptableCompanyException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("company"));
		} catch (InvalidIntervalException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("interval"));			
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
		}catch (InternalErrorException e) {
			e.printStackTrace();
		} 

		return (Long) map.get("id");
		
	}

	protected boolean inputTesting(HashMap map) {

		if (map.get("reservationStatus").equals("Rexistrada") || map.get("reservationStatus").equals("Finalizada")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("reservationStatus"));
			return false;
		}

		if ((((String) map.get("reservatorName")).trim()).equals("")) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("reservatorName"));
			return false;
		}
		
		ErrorsHandler.clear();

		return true;
	}	

}
