package gz.cyberbrain.cyberhotel.model.cash.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;
import gz.cyberbrain.cyberhotel.model.util.dates.DateOperations;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;

public class CashTo implements Identifiable {
	
	private static final long serialVersionUID = -6176451819799618377L;
	private Long cashNumber;
	private Calendar closeDate;
	private long paymentsNumber;
	private BigDecimal cardsTotal;
	private BigDecimal accountsTotal;
	private BigDecimal vouchersTotal;
	private BigDecimal advancesTotal;
	private BigDecimal cashTotal;
	private String user;
	
	public CashTo(){}
	
	public CashTo(Long cashNumber, Calendar closeDate, long paymentsNumber, BigDecimal cardsTotal, BigDecimal accountsTotal, BigDecimal vouchersTotal, BigDecimal advancesTotal, BigDecimal cashTotal, String user) {		
		this.cashNumber = cashNumber;
		this.closeDate = DateOperations.getDateWithoutMilliseconds(closeDate);
		this.paymentsNumber = paymentsNumber;
		this.cardsTotal = cardsTotal;
		this.accountsTotal = accountsTotal;
		this.vouchersTotal = vouchersTotal;
		this.advancesTotal = advancesTotal;
		this.cashTotal = cashTotal;
		this.user = user;
	}
	
	public Serializable getId(){
		return cashNumber;
	}

	public BigDecimal getAccountsTotal() {
		return accountsTotal;
	}

	public void setAccountsTotal(BigDecimal accountsTotal) {
		this.accountsTotal = accountsTotal;
	}

	public BigDecimal getAdvancesTotal() {
		return advancesTotal;
	}

	public void setAdvancesTotal(BigDecimal advancesTotal) {
		this.advancesTotal = advancesTotal;
	}

	public BigDecimal getCardsTotal() {
		return cardsTotal;
	}

	public void setCardsTotal(BigDecimal cardsTotal) {
		this.cardsTotal = cardsTotal;
	}

	public BigDecimal getCashTotal() {
		return cashTotal;
	}

	public void setCashTotal(BigDecimal cashTotal) {
		this.cashTotal = cashTotal;
	}

	public Calendar getCloseDate() {
		return closeDate;
	}

	public void setCloseDate(Calendar closeDate) {
		this.closeDate = closeDate;
	}

	public long getPaymentsNumber() {
		return paymentsNumber;
	}

	public void setPaymentsNumber(long paymentsNumber) {
		this.paymentsNumber = paymentsNumber;
	}

	public String getUser() {
		return user;
	}

	public void setUser(String user) {
		this.user = user;
	}

	public BigDecimal getVouchersTotal() {
		return vouchersTotal;
	}

	public void setVouchersTotal(BigDecimal vouchersTotal) {
		this.vouchersTotal = vouchersTotal;
	}

	public Long getCashNumber() {
		return cashNumber;
	}

	public void setCashNumber(Long cashNumber) {
		this.cashNumber = cashNumber;
	}	
	
	
	
}
