package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.concept.dao.ConceptDao;
import gz.cyberbrain.cyberhotel.model.concept.to.ConceptTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.ConceptInUseException;


public class DeleteConceptAction {

	private ConceptTo conceptTo;
	private ConceptDao conceptDao;

	public DeleteConceptAction (ConceptTo conceptTo, ConceptDao conceptDao) {

		this.conceptTo = conceptTo;
		this.conceptDao = conceptDao;

	}

	public void execute() throws ConceptInUseException, InternalErrorException {

		if (conceptDao.existOwes(conceptTo.getConceptCode())) throw new ConceptInUseException(conceptTo);

		conceptDao.remove(conceptTo);

	}

}
