package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import java.util.Calendar;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.SeasonTariffiedException;
import gz.cyberbrain.cyberhotel.model.day.dao.DayDao;
import gz.cyberbrain.cyberhotel.model.day.to.DayTo;
import gz.cyberbrain.cyberhotel.model.season.dao.SeasonDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteDaySeasonAction {

	private Calendar dayDate;
	private DayDao dayDao;
	private SeasonDao seasonDao;

	public DeleteDaySeasonAction(Calendar dayDate, DayDao dayDao, SeasonDao seasonDao) {

		this.dayDate = dayDate;
		this.dayDao = dayDao;
		this.seasonDao = seasonDao;

	}

	public void execute() throws SeasonTariffiedException, InstanceNotFoundException, InternalErrorException {		
		
		DayTo day = dayDao.find(dayDate);
		
		if (seasonDao.isTariffied(day.getSeason())) 
			throw new SeasonTariffiedException(seasonDao.find(day.getSeason()));
		
		day.setSeason(null);
		
		dayDao.update(day);
		
	}

	
}
