package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.EmployeeWithWashesException;
import gz.cyberbrain.cyberhotel.model.employee.dao.EmployeeDao;
import gz.cyberbrain.cyberhotel.model.employee.to.EmployeeTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeleteEmployeeAction {
	
	private EmployeeTo employeeTo;
	private EmployeeDao employeeDao;
	
	public DeleteEmployeeAction (EmployeeTo employeeTo, EmployeeDao employeeDao) {
		
		this.employeeTo = employeeTo;
		this.employeeDao = employeeDao;
		
	}
	
	public void execute() throws EmployeeWithWashesException, InternalErrorException {
		
		if (!employeeDao.employeeWashes(employeeTo.getEmployeeId()).isEmpty()) 
											throw new EmployeeWithWashesException(employeeTo);
		
		employeeDao.remove(employeeTo);
		
	}
	
}
