package gz.cyberbrain.cyberhotel.model.payment.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;

public class PaymentTo implements Identifiable {
	
	private static final long serialVersionUID = 2191231009825515872L;
	private Long reference;
	private Calendar paymentDate;
	private BigDecimal amount;
	private String payMode;
	private String status;
	private String notes;
	private Long invoiceNumber;
	private String invoiceSerial;
	private String user;
	private Long cash;
	
	public PaymentTo(){}
	
	public PaymentTo(Long reference, Calendar paymentDate, BigDecimal amount, String payMode, String state, String notes, Long invoiceNumber, String invoiceSerial, String user, Long cash) {		
		this.reference = reference;
		this.paymentDate = paymentDate;
		this.amount = amount;
		this.payMode = payMode;
		this.status = state;
		this.notes = notes;
		this.invoiceNumber = invoiceNumber;
		this.invoiceSerial = invoiceSerial;
		this.user = user;
		this.cash = cash;
	}
	
	public Serializable getId(){
		return reference;
	}

	public BigDecimal getAmount() {
		return amount;
	}

	public void setAmount(BigDecimal amount) {
		this.amount = amount;
	}

	public Long getCash() {
		return cash;
	}

	public void setCash(Long cash) {
		this.cash = cash;
	}

	public String getInvoiceSerial() {
		return invoiceSerial;
	}

	public void setInvoiceSerial(String invoiceSerial) {
		this.invoiceSerial = invoiceSerial;
	}

	public String getNotes() {
		return notes;
	}

	public void setNotes(String notes) {
		this.notes = notes;
	}

	public Calendar getPaymentDate() {
		return paymentDate;
	}

	public void setPaymentDate(Calendar paymentDate) {
		this.paymentDate = paymentDate;
	}

	public String getPayMode() {
		return payMode;
	}

	public void setPayMode(String payMode) {
		this.payMode = payMode;
	}

	public Long getReference() {
		return reference;
	}

	public void setReference(Long reference) {
		this.reference = reference;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String state) {
		this.status = state;
	}

	public String getUser() {
		return user;
	}

	public void setUser(String user) {
		this.user = user;
	}

	public Long getInvoiceNumber() {
		return invoiceNumber;
	}

	public void setInvoiceNumber(Long invoiceNumber) {
		this.invoiceNumber = invoiceNumber;
	}
			
}
