package gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions;

import gz.cyberbrain.cyberhotel.model.util.exceptions.ModelException;

public class PriceNotFoundException extends ModelException {
	
	private static final long serialVersionUID = 1L;
	private Long priceId;
	private String board;
	private String priceType;
	private Long season;

	public PriceNotFoundException(Long priceId, String board, String priceType, Long season){

		super("Price (" + priceId + ", " + board + ", " + priceType + ", " + season + ") is not in database.");

		this.priceId = priceId;
		this.board = board;
		this.priceType = priceType;
		this.season = season;

	}

	public Long getPriceId() {
		return priceId;
	}
	
	public String getBoard() {
		return board;
	}
	
	public String getPriceType() {
		return priceType;
	}
	
	public Long getSeason() {
		return season;
	}
	
}
