package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.RoomBusyException;
import gz.cyberbrain.cyberhotel.model.room.dao.RoomDao;
import gz.cyberbrain.cyberhotel.model.room.to.RoomTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class BlockARoomAction {

	private RoomTo roomTo;
	private RoomDao roomDao;
	
	public BlockARoomAction (RoomTo roomTo, RoomDao roomDao) {
		this.roomTo = roomTo;
		this.roomDao = roomDao;
	}
	
	public void execute() 
	throws RoomBusyException, InternalErrorException {
		
		if (roomTo.getOccupancyStatus().equals("Ocupada")) 
			throw new RoomBusyException(roomTo);
		
		if (!roomTo.getOccupancyStatus().equals("Bloqueada")) { 
		
			roomTo.setOccupancyStatus("Bloqueada");
		
			roomDao.update(roomTo);		
		
		}
		
	}
	
}
