package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import java.util.Collection;

import gz.cyberbrain.cyberhotel.model.owe.dao.OweDao;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableRoomException;
import gz.cyberbrain.cyberhotel.model.room.dao.RoomDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class FindOwesByRoomAction {

	private String roomCode;
	private RoomDao roomDao;
	private OweDao oweDao;
	
	public FindOwesByRoomAction (String roomCode, RoomDao roomDao, OweDao oweDao) {
		this.roomCode = roomCode;
		this.roomDao = roomDao;
		this.oweDao = oweDao;
	}
	
	public Collection execute() throws UnaceptableRoomException, InternalErrorException {
		
		try {
			roomDao.find(roomCode);
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableRoomException(roomCode);
		}
			
		
		return oweDao.findByRoom(roomCode);
		
	}
	
}
