package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import java.util.Collection;

import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.owe.dao.OweDao;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableParticularException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.UnaceptableRoomException;
import gz.cyberbrain.cyberhotel.model.room.dao.RoomDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class FindOwesByRoomAndParticularAction {

	private String roomCode;
	private Long particularId;
	private RoomDao roomDao;
	private ClientDao particularDao;
	private OweDao oweDao;
	
	public FindOwesByRoomAndParticularAction (String roomCode, Long particularId, RoomDao roomDao, ClientDao particularDao, OweDao oweDao) {
		this.particularId = particularId;
		this.roomCode = roomCode;
		this.roomDao = roomDao;
		this.particularDao = particularDao;
		this.oweDao = oweDao;
	}
	
	public Collection execute() throws UnaceptableRoomException, InternalErrorException, UnaceptableParticularException {
		
		try {
			roomDao.find(roomCode);
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableRoomException(roomCode);
		}
		
		try {
		particularDao.find(particularId);
		} catch (InstanceNotFoundException e) {
			throw new UnaceptableParticularException(particularId);
		}
		
		return oweDao.findByRoomAndParticular(roomCode, particularId);
		
	}
	
}
