package gz.cyberbrain.cyberhotel.model.reservationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.client.dao.ClientDao;
import gz.cyberbrain.cyberhotel.model.client.to.ParticularTo;

import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientPayerException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ClientWithInvoicesException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ParticularWithOwesException;
import gz.cyberbrain.cyberhotel.model.reservationfacade.exceptions.ParticularWithReservationsException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;


public class RemoveAParticularAction {

	private ParticularTo particularTo;
	private ClientDao particularDao;
	
	public RemoveAParticularAction(ParticularTo particularTo, ClientDao particularDao) {
		this.particularTo = particularTo;
		this.particularDao = particularDao;
	}
	
	public void execute() 
		throws ParticularWithOwesException, ParticularWithReservationsException, 
		ClientPayerException, ClientWithInvoicesException, InternalErrorException {
		
		if (particularDao.existOwes(particularTo.getClientId()))
			throw new ParticularWithOwesException(particularTo);
		
		if (particularDao.existRequests(particularTo.getClientId()))
			throw new ParticularWithReservationsException(particularTo);
		
		if (particularDao.isPayer(particularTo.getClientId()))
			throw new ClientPayerException(particularTo);
		
		if (particularDao.existInvoices(particularTo.getClientId()))
			throw new ClientWithInvoicesException(particularTo);
		
		particularDao.remove(particularTo);
		
	}
	
}
