package gz.cyberbrain.cyberhotel.model.wash.dao;

import gz.cyberbrain.cyberhotel.model.wash.to.WashTo;
import gz.cyberbrain.cyberhotel.model.owe.to.OweTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

public class WashSpringDao extends AbstractSpringDao implements WashDao {

	public WashSpringDao() {
		super(WashTo.class);
	}	

	public WashTo create(WashTo washTo) throws InternalErrorException {		

		return (WashTo) super.save(washTo);

	}

	public WashTo find(String room, Long employee, Long idWash) throws InstanceNotFoundException, InternalErrorException {

		String queryName = "aWash";
		Serializable []attributes = {room, employee, idWash};
		Collection washTo = new ArrayList();
		washTo = super.findByAttributes(queryName,attributes);
		Exception e = new Exception("Wash not unique!");
		
		if (washTo.size() > 1) throw new InternalErrorException(e);
		if (washTo.isEmpty()) throw new InstanceNotFoundException(attributes,OweTo.class.getName());
		Iterator iter = washTo.iterator();
		
		return (WashTo) iter.next();	
	}

	public void update(WashTo washTo) throws InternalErrorException {		

		super.update(washTo);

	}

	public void remove(WashTo washTo) throws InternalErrorException {

			super.delete(washTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allWashes";
		return super.findByQuery(queryName);
		
	}	
	
	public Long nextWash(String roomCode, Long employeeId) 
	throws InternalErrorException {
		
		String queryName = "nextWash";
		Exception e = new Exception("Wash id generator fails!");
		Collection washNumber = new ArrayList();
		Serializable []attributes = {roomCode, employeeId};
		washNumber = super.findByAttributes(queryName, attributes);
		if (washNumber.size() > 1) throw new InternalErrorException(e);
		Iterator iter = washNumber.iterator();
		Integer next = ((Integer) iter.next());
		
		return (next != null? next.longValue() : null);
		
	}
	
}
