package gz.cyberbrain.cyberhotel.view.swing.reception;

import gz.cyberbrain.cyberhotel.controller.AddressController;
import gz.cyberbrain.cyberhotel.controller.BankListAdapter;
import gz.cyberbrain.cyberhotel.controller.CardListAdapter;
import gz.cyberbrain.cyberhotel.controller.SaveAdapter;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.view.swing.FillableWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.ListWindow;
import gz.cyberbrain.cyberhotel.view.swing.edit.RoomTypeWindow;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.AlphanumericDocument;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.ImageItem;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.InfoPanel;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.IntegerDocument;

import javax.swing.JPanel; 

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JTabbedPane;
import java.awt.Rectangle;
import java.io.Serializable;
import java.util.HashMap;

import javax.swing.JButton;
import javax.swing.JLabel;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JInternalFrame;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JScrollPane;
import javax.swing.JTextArea; 
import javax.swing.JComboBox;
import javax.swing.UIManager;
import javax.swing.border.LineBorder;
import javax.swing.text.Document;

public class AgencyWindow extends FillableWindow {

	private static final long serialVersionUID = 1L;
	
	private static AgencyWindow agencyWindow = null;
	
	private Serializable id = null;

	private SaveAdapter saveAdapter = null;
	
	private JInternalFrame owner = null;
	
	private String dialogMessage = null;
	
	private String dialogTitle = null;
	
	private JPanel jContentPane = null;

	private JTabbedPane jTabbedPane = null;

	private JButton saveButton = null;

	private JButton cancelButton = null;
	
	private InfoPanel infoPanel = null;

	private JPanel firstPanel = null;  //  @jve:decl-index=0:visual-constraint="781,120"

	private JLabel nameLabel = null;

	private JLabel contactLabel = null;

	private JTextField nameTextField = null;

	private JTextField contactTextField = null;

	private JLabel countryLabel = null;

	private JLabel provinceLabel = null;

	private JLabel localityLabel = null;

	private JLabel dwellingPlaceLabel = null;

	private JLabel phone1Label = null;

	private JLabel phone2Label = null;

	private JLabel faxLabel = null;

	private JLabel emailLabel = null;

	private JLabel webLabel = null;

	private JLabel notesLabel = null;

	private JTextField dwellingPlaceTextField = null;

	private JTextField phone1TextField = null;

	private JTextField phone2TextField = null;

	private JTextField faxTextField = null;

	private JTextField emailTextField = null;

	private JTextField webTextField = null;

	private JLabel streetLabel = null;

	private JTextField streetTextField = null;

	private JComboBox countryComboBox = null;

	private JComboBox provinceComboBox = null;

	private JComboBox localityComboBox = null;

	private JPanel secondPanel = null;  //  @jve:decl-index=0:visual-constraint="1473,122"

	private JLabel payModeLabel = null;

	private JComboBox payModeComboBox = null;

	private JLabel accountNumLabel = null;

	private JTextField accountNumTextField = null;

	private JLabel cardNumLabel = null;

	private JTextField cardNumTextField = null;

	private JLabel bankLabel = null;

	private JComboBox bankComboBox = null;

	private JLabel cardLabel = null;

	private JComboBox cardComboBox = null;

	private JScrollPane notesScrollPane = null;

	private JTextArea notesTextArea = null;

	private JLabel cifLabel = null;

	private JTextField cifTextField = null;

	/**
	 * @param owner
	 */
	private AgencyWindow() {
		super("",false, true, false, true);
		initialize();
	}
	
	public static AgencyWindow getInstance() {
		if (agencyWindow == null) agencyWindow = new AgencyWindow();
		return agencyWindow;
	}

	public void setAdapter(SaveAdapter saveAdapter) {
		this.saveAdapter = saveAdapter;
	}
	
	public SaveAdapter getAdapter() {
		return saveAdapter;
	}

	public JInternalFrame getOwner() {
		return owner;
	}

	public void setOwner(JInternalFrame owner) {
		this.owner = owner;
	}

	public String getDialogMessage() {
		return dialogMessage;
	}

	public void setDialogMessage(String dialogMessage) {
		this.dialogMessage = dialogMessage;
	}

	public String getDialogTitle() {
		return dialogTitle;
	}

	public void setDialogTitle(String dialogTitle) {
		this.dialogTitle = dialogTitle;
	}
	
	public void setId(Serializable id) {
		this.id = id;
	}
	
	public Serializable getId() {
		return id;
	}
	
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(745, 501);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.setContentPane(getJContentPane());
		this.addInternalFrameListener(new javax.swing.event.InternalFrameAdapter()
        {
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt)
            {
                (AgencyWindow.getInstance()).clean();
                (AgencyWindow.getInstance()).dispose();
 
            }
        });

	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJTabbedPane(), null);
			jContentPane.add(getSaveButton(), null);
			jContentPane.add(getCancelButton(), null);
			jContentPane.add(getInfoPanel(), null);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.setBounds(new Rectangle(3, 58, 731, 381));
			jTabbedPane.add(Locale.get("AgencyWindow.firstTab"),getFirstPanel());
			jTabbedPane.add(Locale.get("AgencyWindow.secondTab"),getSecondPanel());
		}
		return jTabbedPane;
	}

	/**
	 * This method initializes saveButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSaveButton() {
		if (saveButton == null) {
			saveButton = new JButton();
			saveButton.setBounds(new Rectangle(543, 443, 79, 18));
			saveButton.setText(Locale.get("AgencyWindow.saveButton"));
			saveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					HashMap<String, Object> attrs = new HashMap<String, Object>();
					attrs.put("id", (Long) getId());
					
					attrs.put("address", 
							AddressController.findAddressId(
									(String) getCountryComboBox().getSelectedItem(), 
									(String) getProvinceComboBox().getSelectedItem(),
									(String) getLocalityComboBox().getSelectedItem()
							)
					);

					attrs.put("street", getStreetTextField().getText());
					attrs.put("dwellingPlace", getDwellingPlaceTextField().getText()); 
					attrs.put("phone1", getPhone1TextField().getText());
					attrs.put("phone2", getPhone2TextField().getText());
					attrs.put("fax", getFaxTextField().getText());
					attrs.put("email", getEmailTextField().getText()); 
					attrs.put("web", getWebTextField().getText());

					if (getBankComboBox().getItemCount() != 0) attrs.put("bank", (Long) ((ImageItem) getBankComboBox().getSelectedItem()).getId());
					else attrs.put("bank", new Long(0));

					if (getCardComboBox().getItemCount() != 0) attrs.put("card", (Long) ((ImageItem) getCardComboBox().getSelectedItem()).getId());
					else attrs.put("card", null);

					attrs.put("notes", getJTextArea().getText()); 
					attrs.put("cif", getCifTextField().getText());
					attrs.put("name", getNameTextField().getText());
					attrs.put("contact", getContactTextField().getText());

					String payMode = "Contado";
					switch(getPayModeComboBox().getSelectedIndex()) {
					case 0:
						payMode = "Contado";
						break;
					case 1:
						payMode = "Tarxeta";
						break;	
					}
					attrs.put("payMode", payMode);

					attrs.put("accountNumber", getAccountNumTextField().getText());
					attrs.put("cardNumber", getCardNumTextField().getText());					

					getAdapter().save(attrs);

					if (!inputErrors()) {

						setDialogMessage(Locale.get("JOptionPane.AgencyWindow.saveButton.message"));
						setDialogTitle(Locale.get("JOptionPane.AgencyWindow.saveButton.title"));

						Object[] options = {Locale.get("JOptionPane.Ok")};
						int n = JOptionPane.showOptionDialog(RoomTypeWindow.getInstance(),
								getDialogMessage(),
								getDialogTitle(),
								JOptionPane.OK_OPTION,
								JOptionPane.INFORMATION_MESSAGE,
								null,
								options,
								options[0]);

						if (n == JOptionPane.OK_OPTION) {
							ListWindow listWindow = (ListWindow) getOwner();						
							listWindow.loadList();
							clean();
							dispose();	                    	
						}											

						ListWindow listWindow = (ListWindow) getOwner();
						listWindow.loadList();

					}

				}

			});

		}
		return saveButton;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setBounds(new Rectangle(635, 443, 79, 18));
			cancelButton.setText(Locale.get("AgencyWindow.cancelButton"));
			cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					(AgencyWindow.getInstance()).clean();
					(AgencyWindow.getInstance()).dispose();

				}
			});

		}
		return cancelButton;
	}

	private InfoPanel getInfoPanel() {
		if (infoPanel == null) {
			infoPanel = new InfoPanel();
			infoPanel.setBounds(0,0,this.getWidth(),50);
		}
		return infoPanel;
	}

	public void setInfoPanel(InfoPanel ipanel) {		  

		jContentPane.remove(infoPanel);
		infoPanel = ipanel;
		jContentPane.add(infoPanel);

	}

	/**
	 * This method initializes firstPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getFirstPanel() {
		if (firstPanel == null) {
			cifLabel = new JLabel();
			cifLabel.setBounds(new Rectangle(12, 45, 38, 16));
			cifLabel.setText(Locale.get("AgencyWindow.cifLabel"));
			streetLabel = new JLabel();
			streetLabel.setBounds(new Rectangle(12, 158, 63, 16));
			streetLabel.setText(Locale.get("AgencyWindow.streetLabel"));
			notesLabel = new JLabel();
			notesLabel.setBounds(new Rectangle(11, 273, 38, 16));
			notesLabel.setText(Locale.get("AgencyWindow.notesLabel"));
			webLabel = new JLabel();
			webLabel.setBounds(new Rectangle(299, 243, 31, 16));
			webLabel.setText(Locale.get("AgencyWindow.webLabel"));
			emailLabel = new JLabel();
			emailLabel.setBounds(new Rectangle(11, 242, 38, 16));
			emailLabel.setText(Locale.get("AgencyWindow.emailLabel"));
			faxLabel = new JLabel();
			faxLabel.setBounds(new Rectangle(391, 214, 25, 16));
			faxLabel.setText(Locale.get("AgencyWindow.faxLabel"));
			phone2Label = new JLabel();
			phone2Label.setBounds(new Rectangle(223, 214, 25, 16));
			phone2Label.setText(Locale.get("AgencyWindow.phone2Label"));
			phone1Label = new JLabel();
			phone1Label.setBounds(new Rectangle(11, 214, 30, 16));
			phone1Label.setText(Locale.get("AgencyWindow.phone1Label"));
			dwellingPlaceLabel = new JLabel();
			dwellingPlaceLabel.setBounds(new Rectangle(385, 158, 86, 16));
			dwellingPlaceLabel.setText(Locale.get("AgencyWindow.dwellingPlaceLabel"));
			localityLabel = new JLabel();
			localityLabel.setBounds(new Rectangle(12, 127, 63, 16));
			localityLabel.setText(Locale.get("AgencyWindow.localityLabel"));
			provinceLabel = new JLabel();
			provinceLabel.setBounds(new Rectangle(12, 98, 63, 16));
			provinceLabel.setText(Locale.get("AgencyWindow.provinceLabel"));
			countryLabel = new JLabel();
			countryLabel.setBounds(new Rectangle(12, 72, 63, 16));
			countryLabel.setText(Locale.get("AgencyWindow.countryLabel"));
			contactLabel = new JLabel();
			contactLabel.setBounds(new Rectangle(330, 14, 75, 15));
			contactLabel.setText(Locale.get("AgencyWindow.contactLabel"));
			nameLabel = new JLabel();
			nameLabel.setBounds(new Rectangle(12, 14, 50, 15));
			nameLabel.setText(Locale.get("AgencyWindow.nameLabel"));
			firstPanel = new JPanel();
			firstPanel.setLayout(null);
			firstPanel.setSize(new Dimension(684, 341));
			firstPanel.add(nameLabel, null);
			firstPanel.add(contactLabel, null);
			firstPanel.add(getNameTextField(), null);
			firstPanel.add(getContactTextField(), null);
			firstPanel.add(countryLabel, null);
			firstPanel.add(provinceLabel, null);
			firstPanel.add(localityLabel, null);
			firstPanel.add(dwellingPlaceLabel, null);
			firstPanel.add(phone1Label, null);
			firstPanel.add(phone2Label, null);
			firstPanel.add(faxLabel, null);
			firstPanel.add(emailLabel, null);
			firstPanel.add(webLabel, null);
			firstPanel.add(notesLabel, null);
			firstPanel.add(getDwellingPlaceTextField(), null);
			firstPanel.add(getPhone1TextField(), null);
			firstPanel.add(getPhone2TextField(), null);
			firstPanel.add(getFaxTextField(), null);
			firstPanel.add(getEmailTextField(), null);
			firstPanel.add(getWebTextField(), null);
			firstPanel.add(streetLabel, null);
			firstPanel.add(getStreetTextField(), null);
			firstPanel.add(getCountryComboBox(), null);
			firstPanel.add(getProvinceComboBox(), null);
			firstPanel.add(getLocalityComboBox(), null);
			firstPanel.add(getNotesTextArea(), null);			 
			firstPanel.add(getNotesScrollPane(), null);
			firstPanel.add(cifLabel, null);
			firstPanel.add(getCifTextField(), null);
		}
		return firstPanel;
	}

	/**
	 * This method initializes nameTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getNameTextField() {
		if (nameTextField == null) {
			nameTextField = new JTextField();
			nameTextField.setBounds(new Rectangle(94, 14, 230, 18));
		}
		return nameTextField;
	}

	/**
	 * This method initializes contactTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getContactTextField() {
		if (contactTextField == null) {
			contactTextField = new JTextField();
			contactTextField.setBounds(new Rectangle(412, 14, 230, 18));
		}
		return contactTextField;
	}

	/**
	 * This method initializes dwellingPlaceTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getDwellingPlaceTextField() {
		if (dwellingPlaceTextField == null) {
			dwellingPlaceTextField = new JTextField();
			dwellingPlaceTextField.setBounds(new Rectangle(476, 157, 198, 18));
		}
		return dwellingPlaceTextField;
	}

	/**
	 * This method initializes phone1TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPhone1TextField() {
		if (phone1TextField == null) {
			Document integerDocument = new IntegerDocument(15);
			phone1TextField = new JTextField(integerDocument,"",15);
			phone1TextField.setHorizontalAlignment(JTextField.TRAILING);
			phone1TextField.setBounds(new Rectangle(93, 214, 124, 18));
		}
		return phone1TextField;
	}

	/**
	 * This method initializes phone2TextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPhone2TextField() {
		if (phone2TextField == null) {
			Document integerDocument = new IntegerDocument(15);
			phone2TextField = new JTextField(integerDocument,"",15);
			phone2TextField.setHorizontalAlignment(JTextField.TRAILING);
			phone2TextField.setBounds(new Rectangle(251, 214, 130, 18));
		}
		return phone2TextField;
	}

	/**
	 * This method initializes faxTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getFaxTextField() {
		if (faxTextField == null) {
			faxTextField = new JTextField();
			faxTextField.setHorizontalAlignment(JTextField.TRAILING);
			faxTextField.setBounds(new Rectangle(419, 214, 130, 18));
		}
		return faxTextField;
	}

	/**
	 * This method initializes emailTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getEmailTextField() {
		if (emailTextField == null) {
			emailTextField = new JTextField();
			emailTextField.setBounds(new Rectangle(93, 242, 193, 18));
		}
		return emailTextField;
	}

	/**
	 * This method initializes webTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getWebTextField() {
		if (webTextField == null) {
			webTextField = new JTextField();
			webTextField.setBounds(new Rectangle(335, 242, 338, 18));
		}
		return webTextField;
	}

	/**
	 * This method initializes notesTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getNotesTextArea() {
		if (notesTextArea == null) {
			notesTextArea = new JTextArea();
			notesTextArea.setBounds(new Rectangle(93, 271, 578, 53));
		}
		return notesTextArea;
	}

	/**
	 * This method initializes streetTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getStreetTextField() {
		if (streetTextField == null) {
			streetTextField = new JTextField();
			streetTextField.setBounds(new Rectangle(94, 157, 282, 18));
		}
		return streetTextField;
	}

	/**
	 * This method initializes countryComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getCountryComboBox() {
		if (countryComboBox == null) {
			countryComboBox = new JComboBox(AddressController.countriesList().toArray());
			countryComboBox.setBounds(new Rectangle(94, 72, 213, 18));
			countryComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {


					ComboBoxModel model = new DefaultComboBoxModel(AddressController.countryProvincesList((String)getCountryComboBox().getSelectedItem()).toArray());
					getProvinceComboBox().setModel(model);
					if (getProvinceComboBox().getItemCount() != 0) getProvinceComboBox().setSelectedIndex(0); 


				}
			});

		}
		return countryComboBox;
	}

	/**
	 * This method initializes provinceComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getProvinceComboBox() {
		if (provinceComboBox == null) {
			provinceComboBox = new JComboBox(AddressController.countryProvincesList((String) getCountryComboBox().getSelectedItem()).toArray());
			provinceComboBox.setBounds(new Rectangle(94, 98, 213, 18));
			provinceComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					ComboBoxModel model = new DefaultComboBoxModel(AddressController.provinceLocalitiesList((String)getCountryComboBox().getSelectedItem(), (String)getProvinceComboBox().getSelectedItem()).toArray());
					getLocalityComboBox().setModel(model);						
					if (getLocalityComboBox().getItemCount() != 0) getLocalityComboBox().setSelectedIndex(0);

				}
			});

		}
		return provinceComboBox;
	}

	/**
	 * This method initializes localityComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getLocalityComboBox() {
		if (localityComboBox == null) {
			localityComboBox = new JComboBox(AddressController.provinceLocalitiesList((String)getCountryComboBox().getSelectedItem(), (String)getProvinceComboBox().getSelectedItem()).toArray());
			localityComboBox.setBounds(new Rectangle(94, 127, 213, 18));
		}
		return localityComboBox;
	}

	/**
	 * This method initializes secondPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getSecondPanel() {
		if (secondPanel == null) {
			cardLabel = new JLabel();
			cardLabel.setBounds(new Rectangle(21, 90, 66, 16));
			cardLabel.setText(Locale.get("AgencyWindow.cardLabel"));
			bankLabel = new JLabel();
			bankLabel.setBounds(new Rectangle(21, 59, 66, 16));
			bankLabel.setText(Locale.get("AgencyWindow.bankLabel"));
			cardNumLabel = new JLabel();
			cardNumLabel.setBounds(new Rectangle(252, 59, 73, 16));
			cardNumLabel.setText(Locale.get("AgencyWindow.cardNumLabel"));
			accountNumLabel = new JLabel();
			accountNumLabel.setBounds(new Rectangle(252, 27, 73, 16));
			accountNumLabel.setText(Locale.get("AgencyWindow.accountNumLabel"));
			payModeLabel = new JLabel();
			payModeLabel.setBounds(new Rectangle(21, 28, 66, 16));
			payModeLabel.setText(Locale.get("AgencyWindow.payModeLabel"));
			secondPanel = new JPanel();
			secondPanel.setLayout(null);
			secondPanel.setSize(new Dimension(658, 339));
			secondPanel.add(payModeLabel, null);
			secondPanel.add(getPayModeComboBox(), null);
			secondPanel.add(accountNumLabel, null);
			secondPanel.add(getAccountNumTextField(), null);
			secondPanel.add(cardNumLabel, null);
			secondPanel.add(getCardNumTextField(), null);
			secondPanel.add(bankLabel, null);
			secondPanel.add(getBankComboBox(), null);
			secondPanel.add(cardLabel, null);
			secondPanel.add(getCardComboBox(), null);
		}
		return secondPanel;
	}

	/**
	 * This method initializes payModeComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getPayModeComboBox() {
		if (payModeComboBox == null) {
			payModeComboBox = new JComboBox();
			payModeComboBox.setBounds(new Rectangle(96, 27, 146, 19));
			payModeComboBox.addItem(Locale.get("AgencyWindow.payModeComboBox.item0"));
			payModeComboBox.addItem(Locale.get("AgencyWindow.payModeComboBox.item1"));
			payModeComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					switch (payModeComboBox.getSelectedIndex()) {

					case 0:						
						getBankComboBox().setEnabled(true);
						getAccountNumTextField().setEnabled(true);
						getCardComboBox().setEnabled(false);						
						getCardNumTextField().setEnabled(false);
						getCardNumTextField().setBackground(new Color(248,248,248));						
						break;
					case 1:
						getCardComboBox().setEnabled(true);
						getCardNumTextField().setEnabled(true);
						getCardNumTextField().setBackground(Color.WHITE);
						getBankComboBox().setEnabled(false);
						getAccountNumTextField().setEnabled(false);												
						break;
					}
				}
			});

		}
		return payModeComboBox;
	}

	/**
	 * This method initializes accountNumTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getAccountNumTextField() {
		if (accountNumTextField == null) {
			accountNumTextField = new JTextField();
			accountNumTextField.setHorizontalAlignment(JTextField.TRAILING);
			accountNumTextField.setBounds(new Rectangle(332, 27, 326, 20));
		}
		return accountNumTextField;
	}

	/**
	 * This method initializes cardNumTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getCardNumTextField() {
		if (cardNumTextField == null) {
			Document integerDocument = new IntegerDocument(16);
			cardNumTextField = new JTextField(integerDocument,"",16);							
			cardNumTextField.setHorizontalAlignment(JTextField.TRAILING);
			cardNumTextField.setBounds(new Rectangle(332, 60, 326, 20));
		}
		return cardNumTextField;
	}

	/**
	 * This method initializes bankComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getBankComboBox() {
		if (bankComboBox == null) {
			bankComboBox = new JComboBox((new BankListAdapter()).load());
			bankComboBox.setBounds(new Rectangle(96, 59, 146, 19));
		}
		return bankComboBox;
	}

	/**
	 * This method initializes cardComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getCardComboBox() {
		if (cardComboBox == null) {
			cardComboBox = new JComboBox((new CardListAdapter()).load());
			cardComboBox.setBounds(new Rectangle(96, 90, 146, 19));
		}
		return cardComboBox;
	}

	/**
	 * This method initializes notesScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getNotesScrollPane() {
		if (notesScrollPane == null) {
			notesScrollPane = new JScrollPane();
			notesScrollPane.setBounds(new Rectangle(93, 274, 578, 53));
			notesScrollPane.setViewportView(getJTextArea());
		}
		return notesScrollPane;
	}

	/**
	 * This method initializes notesTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getJTextArea() {
		if (notesTextArea == null) {
			notesTextArea = new JTextArea();
		}
		return notesTextArea;
	}

	public void clean() {
		
		getInfoPanel().setInfoText(getInfoPanel().getInfoText());
		getJTabbedPane().setSelectedIndex(0);
		getNameTextField().setText("");		
		getContactTextField().setText("");
		getCifTextField().setText("");
		if (getCountryComboBox().getItemCount() != 0) getCountryComboBox().setSelectedIndex(0);
		if (getProvinceComboBox().getItemCount() != 0) getProvinceComboBox().setSelectedIndex(0);
		if (getLocalityComboBox().getItemCount() != 0) getLocalityComboBox().setSelectedIndex(0);
		getStreetTextField().setText("");
		getDwellingPlaceTextField().setText("");
		getPhone1TextField().setText("");
		getPhone2TextField().setText("");
		getFaxTextField().setText("");
		getEmailTextField().setText("");
		getWebTextField().setText("");
		getNotesTextArea().setText("");
		if (getPayModeComboBox().getItemCount() !=0) getPayModeComboBox().setSelectedIndex(0);
		getAccountNumTextField().setText("");
		getCardNumTextField().setText("");
		if (getBankComboBox().getItemCount() != 0) getBankComboBox().setSelectedIndex(0);
		if (getCardComboBox().getItemCount() != 0) getCardComboBox().setSelectedIndex(0); 
		getCifTextField().setBorder(UIManager.getBorder("TextField.border"));
		getNameTextField().setBorder(UIManager.getBorder("TextField.border"));
		getCountryComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getProvinceComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getLocalityComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getBankComboBox().setBorder(UIManager.getBorder("ComboBox.border"));
		getCardComboBox().setBorder(UIManager.getBorder("ComboBox.border"));

	}

	/**
	 * This method initializes cifTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getCifTextField() {
		if (cifTextField == null) {
			Document alphaDocument = new AlphanumericDocument(9);
			cifTextField = new JTextField(alphaDocument,"",9);
			cifTextField.setBounds(new Rectangle(94, 45, 80, 18));
		}
		return cifTextField;
	}

	@Override
	public void fill(HashMap fields) {

		getCifTextField().setText((String) fields.get("cif"));		
		getNameTextField().setText((String) fields.get("name"));
		getContactTextField().setText((String) fields.get("contact"));

		getCountryComboBox().setSelectedItem(AddressController.addressCountry((Long) fields.get("address")));
		getProvinceComboBox().setSelectedItem(AddressController.addressProvince((Long) fields.get("address")));
		getLocalityComboBox().setSelectedItem(AddressController.addressLocality((Long) fields.get("address")));
		getStreetTextField().setText((String) fields.get("street"));
		getDwellingPlaceTextField().setText((String) fields.get("dwellingPlace"));

		getPhone1TextField().setText((String) fields.get("phone1"));
		getPhone2TextField().setText((String) fields.get("phone2"));
		getFaxTextField().setText((String) fields.get("fax"));
		getEmailTextField().setText((String) fields.get("email"));
		getWebTextField().setText((String) fields.get("web"));
		getJTextArea().setText((String) fields.get("notes"));

		if (((String) fields.get("payMode")).equals("Contado")) getPayModeComboBox().setSelectedIndex(0);
		if (((String) fields.get("payMode")).equals("Tarxeta")) getPayModeComboBox().setSelectedIndex(1);
		if (((String) fields.get("payMode")).equals("Bono")) getPayModeComboBox().setSelectedIndex(2);

		getAccountNumTextField().setText((String) fields.get("accountNumber"));

		for (int i=0; i<getBankComboBox().getItemCount(); i++) {
			ImageItem item = (ImageItem) getBankComboBox().getItemAt(i); 
			if ((item.getId()).equals(((ImageItem) fields.get("bank")).getId())) {
				getBankComboBox().setSelectedIndex(i);
			}
		}

		getCardNumTextField().setText((String) fields.get("cardNumber"));

		for (int i=0; i<getCardComboBox().getItemCount(); i++) {
			ImageItem item = (ImageItem) getCardComboBox().getItemAt(i); 
			if ((item.getId()).equals(((ImageItem) fields.get("card")).getId())) {
				getCardComboBox().setSelectedIndex(i);
			}
		}		
		
	}

	private boolean inputErrors() {

		if (!ErrorsHandler.getErrors().isEmpty()) {

			if (ErrorsHandler.getErrorAt(0).getItem().equals("cif")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("AgencyWindow.errors.cif")+ "</html>");
				getJTabbedPane().setSelectedIndex(0);
				getCifTextField().setBorder(new LineBorder(Color.red, 2));			
				Toolkit.getDefaultToolkit().beep();
				return true;
			}
			
			if (ErrorsHandler.getErrorAt(0).getItem().equals("name")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("AgencyWindow.errors.name")+ "</html>");
				getJTabbedPane().setSelectedIndex(0);
				getNameTextField().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("address")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("AgencyWindow.errors.address")+ "</html>");
				getJTabbedPane().setSelectedIndex(0);
				getCountryComboBox().setBorder(new LineBorder(Color.red, 2));
				getProvinceComboBox().setBorder(new LineBorder(Color.red, 2));
				getLocalityComboBox().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("bank")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("AgencyWindow.errors.bank")+ "</html>");
				getJTabbedPane().setSelectedIndex(1);
				getBankComboBox().setBorder(new LineBorder(Color.red, 2));			
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("card")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("AgencyWindow.errors.card")+ "</html>");
				getJTabbedPane().setSelectedIndex(1);
				getCardComboBox().setBorder(new LineBorder(Color.red, 2));			
				Toolkit.getDefaultToolkit().beep();
				return true;
			}						

		}

		return false;

	}
	
}  //  @jve:decl-index=0:visual-constraint="10,10"
