package gz.cyberbrain.cyberhotel.view.swing.reception;

import gz.cyberbrain.cyberhotel.controller.ConceptController;
import gz.cyberbrain.cyberhotel.controller.ConceptListAdapter;
import gz.cyberbrain.cyberhotel.controller.OweController;
import gz.cyberbrain.cyberhotel.controller.ParticularController;
import gz.cyberbrain.cyberhotel.controller.ParticularListAdapter;
import gz.cyberbrain.cyberhotel.controller.RoomController;
import gz.cyberbrain.cyberhotel.controller.RoomListAdapter;
import gz.cyberbrain.cyberhotel.controller.SaveAdapter;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.AutofitTableColumns;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.DateRenderer;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.NumberEditor;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.OwesTableModel;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.InfoPanel;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TableItem;
import gz.cyberbrain.cyberhotel.view.swing.util.gui.TextItem;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

import javax.swing.JPanel;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;

import java.awt.Rectangle;
import java.math.BigDecimal;
import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Vector;

import javax.swing.DefaultCellEditor;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JButton;

import org.jdesktop.swingx.table.DatePickerCellEditor;

public class OweWindow extends JInternalFrame {

	private static final long serialVersionUID = 1L;
	private static OweWindow oweWindow = null;
	private JPanel jContentPane = null;
	private InfoPanel infoPanel = null;
	private SaveAdapter saveAdapter = null;
	private String dialogMessage = null;
	private String dialogTitle = null;
	private JLabel roomLabel = null;
	private JComboBox roomComboBox = null;
	private JLabel particularLabel = null;
	private JComboBox particularComboBox = null;
	private JComboBox conceptComboBox = null;
	private JComboBox statusComboBox = null;
	private JScrollPane owesScrollPane = null;
	private JTable owesTable = null;
	private JButton addButton = null;
	private JButton saveButton = null;
	private JButton exitButton = null;
	private JButton delButton = null;

	/**
	 * This is the xxx default constructor
	 */
	private OweWindow() {
		super("", false, true, false, true);
		initialize();
	}

	public static OweWindow getInstance() {
		if (oweWindow == null) oweWindow = new OweWindow();
		return oweWindow;
	}

	public void setAdapter(SaveAdapter saveAdapter) {
		this.saveAdapter = saveAdapter;
	}

	public SaveAdapter getAdapter() {
		return saveAdapter;
	}

	public String getDialogMessage() {
		return dialogMessage;
	}

	public void setDialogMessage(String dialogMessage) {
		this.dialogMessage = dialogMessage;
	}

	public String getDialogTitle() {
		return dialogTitle;
	}

	public void setDialogTitle(String dialogTitle) {
		this.dialogTitle = dialogTitle;
	}

	/**
	 * This method initializes infoPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private InfoPanel getInfoPanel() {
		if (infoPanel == null) {
			infoPanel = new InfoPanel();
			infoPanel.setBounds(new Rectangle(0, 0, this.getWidth(), 50));
		}
		return infoPanel;
	}

	public void setInfoPanel(InfoPanel ipanel) {		  

		jContentPane.remove(infoPanel);
		infoPanel = ipanel;
		jContentPane.add(infoPanel);

	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(851, 677);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		this.addInternalFrameListener(new javax.swing.event.InternalFrameAdapter() {

			public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {

				oweWindow = null;			

			}

		});
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			particularLabel = new JLabel();
			particularLabel.setBounds(new Rectangle(182, 58, 61, 16));
			particularLabel.setText(Locale.get("OweWindow.particularLabel"));
			roomLabel = new JLabel();
			roomLabel.setBounds(new Rectangle(17, 58, 62, 16));
			roomLabel.setText(Locale.get("OweWindow.roomLabel"));
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getInfoPanel(), null);
			jContentPane.add(roomLabel, null);
			jContentPane.add(getRoomComboBox(), null);
			jContentPane.add(particularLabel, null);
			jContentPane.add(getParticularComboBox(), null);
			jContentPane.add(getOwesScrollPane(), null);
			jContentPane.add(getAddButton(), null);
			jContentPane.add(getSaveButton(), null);
			jContentPane.add(getCancelButton(), null);
			jContentPane.add(getDelButton(), null);			
		}
		return jContentPane;
	}

	@SuppressWarnings("unchecked")
	private Vector getRooms() {
		Vector rooms = (new RoomListAdapter()).load();
		rooms.insertElementAt(new TextItem(new String(""),""), 0);
		return rooms;
	}

	/**
	 * This method initializes roomComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getRoomComboBox() {
		if (roomComboBox == null) {						

			roomComboBox = new JComboBox(getRooms());
			roomComboBox.setBounds(new Rectangle(84, 57, 90, 19));
			roomComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					jContentPane = null;
					owesScrollPane = null;
					owesTable = null;
					(OweWindow.getInstance()).setContentPane(getJContentPane());

					if (roomComboBox.getSelectedIndex() != 0 || getParticularComboBox().getSelectedIndex() != 0) {
						getAddButton().setEnabled(true);
						getDelButton().setEnabled(true);
					}

					else {
						getAddButton().setEnabled(false);
						getDelButton().setEnabled(false);
					}

				}
			});
		}
		return roomComboBox;
	}

	@SuppressWarnings("unchecked")
	private Vector getParticulars() {
		Vector particulars = (new ParticularListAdapter()).load();
		particulars.insertElementAt(new TextItem(new Long(0),""), 0);
		return particulars;
	}

	/**
	 * This method initializes particularComboBox	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	@SuppressWarnings("unchecked")
	private JComboBox getParticularComboBox() {
		if (particularComboBox == null) {			

			particularComboBox = new JComboBox(getParticulars());
			particularComboBox.setBounds(new Rectangle(252, 57, 259, 19));
			particularComboBox.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					jContentPane = null;
					owesScrollPane = null;
					owesTable = null;
					(OweWindow.getInstance()).setContentPane(getJContentPane());

					if (getRoomComboBox().getSelectedIndex() != 0 || particularComboBox.getSelectedIndex() != 0) {
						getAddButton().setEnabled(true);
						getDelButton().setEnabled(true);
					}
					else {
						getAddButton().setEnabled(false);
						getDelButton().setEnabled(false);
					}

				}
			});
		}
		return particularComboBox;
	}

	private JComboBox getConceptComboBox() {
		if (conceptComboBox == null) {
			Vector concepts = (new ConceptListAdapter()).load();
			conceptComboBox = new JComboBox(concepts);
		}
		return conceptComboBox;		
	}

	private JComboBox getStatusComboBox() {
		if (statusComboBox == null) {
			Vector <TextItem> status = new Vector<TextItem>();
			status.add(new TextItem("Pendente", Locale.get("OweWindow.statusComboBox.outstanding")));
			status.add(new TextItem("Facturado", Locale.get("OweWindow.statusComboBox.billed")));
			statusComboBox = new JComboBox(status);
			statusComboBox.setSelectedIndex(0);
		}		
		return statusComboBox;
	}

	/**
	 * This method initializes owesScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getOwesScrollPane() {
		if (owesScrollPane == null) {
			owesScrollPane = new JScrollPane();
			owesScrollPane.setBounds(new Rectangle(17, 88, 807, 517));
			owesScrollPane.setViewportView(getOwesTable());
		}
		return owesScrollPane;
	}

	private Object [][] loadData() {

		Object [][] data = null;

		Vector rows = new Vector();

		if (getRoomComboBox().getSelectedIndex() != 0 && getParticularComboBox().getSelectedIndex() != 0) {
			rows = OweController.owesByRoomAndParticular((String) ((TextItem) getRoomComboBox().getSelectedItem()).getId(),
					(Long) ((TextItem) getParticularComboBox().getSelectedItem()).getId());
		} else if (getRoomComboBox().getSelectedIndex() != 0) {
			rows = OweController.owesByRoom((String) ((TextItem) getRoomComboBox().getSelectedItem()).getId());
		} else if (getParticularComboBox().getSelectedIndex() != 0){
			rows = OweController.owesByParticular((Long) ((TextItem) getParticularComboBox().getSelectedItem()).getId());
		}

		data = new Object[rows.size()][9];				

		for (int i = 0; i<rows.size(); i++) {
			TableItem item = (TableItem) rows.elementAt(i);
			data[i][0] = (Date) ((Calendar) item.getColumn(0)).getTime();
			data[i][1] = (TextItem) item.getColumn(1);
			data[i][2] = (TextItem) item.getColumn(2);
			data[i][3] = (TextItem) item.getColumn(3);
			data[i][4] = (BigDecimal) item.getColumn(4);
			data[i][5] = (BigDecimal) item.getColumn(5);
			data[i][6] = (BigDecimal) item.getColumn(6);
			if (((String) item.getColumn(7)).equals("Pendente")) data[i][7] = new TextItem("Pendente", Locale.get("OweWindow.statusComboBox.outstanding"));
			if (((String) item.getColumn(7)).equals("Facturado")) data[i][7] = new TextItem("Facturado", Locale.get("OweWindow.statusComboBox.billed"));
			data[i][8] = (Long) ((Long) item.getId()[0]).longValue();			
		}

		return data;

	}

	private String[] loadTitles() {

		String [] titles = {
				Locale.get("OweWindow.owesTable.firstColumn.title"),
				Locale.get("OweWindow.owesTable.secondColumn.title"),
				Locale.get("OweWindow.owesTable.thirdColumn.title"),
				Locale.get("OweWindow.owesTable.fourthColumn.title"),
				Locale.get("OweWindow.owesTable.fifthColumn.title"),
				Locale.get("OweWindow.owesTable.sixthColumn.title"),
				Locale.get("OweWindow.owesTable.seventhColumn.title"),
				Locale.get("OweWindow.owesTable.eighthColumn.title")
		};

		return titles;
	}


	/**
	 * This method initializes owesTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getOwesTable() {
		if (owesTable == null) {
			owesTable = new JTable() {

				private static final long serialVersionUID = 1L;

				public boolean isCellEditable(int row, int col) {
					return col == 7 ? false : true;
				}								

			};

			owesTable.setModel(new OwesTableModel(loadData(), loadTitles()));
			if (owesTable.getRowCount() > 0 ) owesTable.setRowSelectionInterval(0, 0);
			owesTable.getColumnModel().getColumn(0).setCellEditor(new DatePickerCellEditor(DateFormat.getDateInstance(DateFormat.SHORT)));
			owesTable.getColumnModel().getColumn(0).setCellRenderer(new DateRenderer());			
			owesTable.getColumnModel().getColumn(1).setCellEditor(new DefaultCellEditor(new JComboBox(getRooms())));
			owesTable.getColumnModel().getColumn(2).setCellEditor(new DefaultCellEditor(new JComboBox(getParticulars())));			
			owesTable.getColumnModel().getColumn(3).setCellEditor(new DefaultCellEditor(getConceptComboBox()));
			owesTable.getColumnModel().getColumn(4).setCellEditor(new NumberEditor());
			owesTable.getColumnModel().getColumn(5).setCellEditor(new NumberEditor());
			owesTable.getColumnModel().getColumn(6).setCellEditor(new NumberEditor());
			owesTable.getColumnModel().getColumn(7).setCellEditor(new DefaultCellEditor(getStatusComboBox()));

			owesTable.getModel().addTableModelListener(new javax.swing.event.TableModelListener() {

				public void tableChanged(javax.swing.event.TableModelEvent e) {}

			});

			AutofitTableColumns.autoResizeTable(owesTable, true);

		}
		return owesTable;
	}

	/**
	 * This method initializes addButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getAddButton() {
		if (addButton == null) {
			addButton = new JButton();
			addButton.setBounds(new Rectangle(667, 58, 72, 16));
			addButton.setText(Locale.get("OweWindow.addButton"));
			addButton.setEnabled(false);
			addButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					OwesTableModel tableModel = (OwesTableModel) getOwesTable().getModel();
					Vector<Object> row = new Vector<Object>();
					row.add(0, (Calendar.getInstance()).getTime());
					row.add(1, getRoomComboBox().getSelectedItem());
					row.add(2, getParticularComboBox().getSelectedItem());
					row.add(3,null);
					row.add(4,null);
					row.add(5,null);
					row.add(6,null);					
					row.add(7,getStatusComboBox().getSelectedItem());					
					tableModel.addRow(row);					
					getOwesTable().setRowSelectionInterval(getOwesTable().getRowCount() - 1, getOwesTable().getRowCount() - 1);					

				}
			});

		}
		return addButton;
	}

	/**
	 * This method initializes delButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getDelButton() {
		if (delButton == null) {
			delButton = new JButton();
			delButton.setBounds(new Rectangle(750, 58, 72, 16));
			delButton.setText(Locale.get("OweWindow.delButton"));
			delButton.setEnabled(false);
			delButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					setDialogMessage(Locale.get("JOptionPane.OweWindow.delButton.message"));
					setDialogTitle(Locale.get("JOptionPane.OweWindow.delButton.title"));					

					Object[] options = {Locale.get("JOptionPane.Yes"), Locale.get("JOptionPane.No")};
					int n = JOptionPane.showOptionDialog(OweWindow.getInstance(),
							getDialogMessage(),
							getDialogTitle(),
							JOptionPane.YES_NO_OPTION,
							JOptionPane.INFORMATION_MESSAGE,
							null,
							options,
							options[0]);

					if (n == JOptionPane.YES_OPTION && checkRowValues(getOwesTable().getSelectedRow())) {												

						Long oweNumber = (Long) ((OwesTableModel) getOwesTable().getModel()).getCustomValueAt(getOwesTable().getSelectedRow(), 8);

						OweController.deleteOwe(oweNumber);

						OwesTableModel tableModel = (OwesTableModel) getOwesTable().getModel();
						tableModel.removeDataRow(getOwesTable().getSelectedRow());
						tableModel.removeRow(getOwesTable().getSelectedRow());						
						getOwesTable().setModel(tableModel);

						if (getOwesTable().getRowCount() != 0) getOwesTable().setRowSelectionInterval(0, 0);

					}

					if (n == JOptionPane.YES_OPTION && !checkRowValues(getOwesTable().getSelectedRow())) {
						OwesTableModel tableModel = (OwesTableModel) getOwesTable().getModel();
						tableModel.removeRow(getOwesTable().getSelectedRow());						
						getOwesTable().setModel(tableModel);
						if (getOwesTable().getRowCount() != 0) getOwesTable().setRowSelectionInterval(getOwesTable().getRowCount()-1, getOwesTable().getRowCount()-1);
					}

				}
			});

		}
		return delButton;
	}

	/**
	 * This method initializes saveButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getSaveButton() {
		if (saveButton == null) {
			saveButton = new JButton();
			saveButton.setBounds(new Rectangle(656, 613, 77, 17));
			saveButton.setText(Locale.get("OweWindow.saveButton"));
			saveButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					boolean saveOk = true;

					for (int i = 0; i < getOwesTable().getModel().getRowCount(); i++) {

						OwesTableModel tableModel = (OwesTableModel) getOwesTable().getModel();					

						if (i > tableModel.getDataRowCount() - 1 && checkRowValues(i)) {					

							Object[] row = {
									(Date) getOwesTable().getValueAt(i, 0),
									(String) ((TextItem) getOwesTable().getValueAt(i, 1)).getId(),
									(Long) ((TextItem) getOwesTable().getValueAt(i, 2)).getId(),
									(String) ((TextItem) getOwesTable().getValueAt(i, 3)).getId(),
									new BigDecimal(getOwesTable().getValueAt(i, 4).toString()),
									new BigDecimal(getOwesTable().getValueAt(i, 5).toString()),
									new BigDecimal(getOwesTable().getValueAt(i, 6).toString()),
									(String) ((TextItem) getOwesTable().getValueAt(i, 7)).getId(),
									new Long(0)																	
							};

							tableModel.addDataRow(row);
							getOwesTable().setModel(tableModel);

							Calendar oweDate = Calendar.getInstance();
							oweDate.setTime((Date) getOwesTable().getValueAt(i, 0));															
							String room = (String) ((TextItem) getOwesTable().getValueAt(i, 1)).getId();
							Long particular = (Long)((TextItem) getOwesTable().getValueAt(i, 2)).getId();
							String concept= (String)((TextItem) getOwesTable().getValueAt(i, 3)).getId();
							BigDecimal price = new BigDecimal(getOwesTable().getValueAt(i, 4).toString());
							BigDecimal vat = new BigDecimal(getOwesTable().getValueAt(i, 5).toString());
							BigDecimal amount = new BigDecimal( getOwesTable().getValueAt(i, 6).toString());
							String status = (String)((TextItem) getOwesTable().getValueAt(i, 7)).getId();
							Long invoiceNumber = null;
							String invoiceSerial = null;
							BigDecimal discount = null; //No offers implemented		
							Long oweNumber = (Long) ((OwesTableModel) getOwesTable().getModel()).getCustomValueAt(i, 8);


							OweController.createOwe(oweNumber, oweDate, price, vat, amount, discount, status, particular, room, invoiceNumber, invoiceSerial, concept);


						}

						else if (checkRowValues(i)) {

							Calendar oweDate = Calendar.getInstance();
							oweDate.setTime((Date) getOwesTable().getValueAt(i, 0));												
							String room = (String) ((TextItem) getOwesTable().getValueAt(i, 1)).getId();
							Long particular = (Long)((TextItem) getOwesTable().getValueAt(i, 2)).getId();
							String concept = (String)((TextItem) getOwesTable().getValueAt(i, 3)).getId();
							BigDecimal price = new BigDecimal(getOwesTable().getValueAt(i, 4).toString());
							BigDecimal vat = new BigDecimal(getOwesTable().getValueAt(i, 5).toString());
							BigDecimal amount = new BigDecimal( getOwesTable().getValueAt(i, 6).toString());
							String status = (String)((TextItem) getOwesTable().getValueAt(i, 7)).getId();
							Long invoiceNumber = null;
							String invoiceSerial = null;
							BigDecimal discount = null; //No offers implemented		
							Long oweNumber = (Long) ((OwesTableModel) getOwesTable().getModel()).getCustomValueAt(i, 8);

							OweController.updateOwe(oweNumber, oweDate, price, vat, amount, discount, status, particular, room, invoiceNumber, invoiceSerial, concept);

						}

						if (!checkRowValues(i)) {
							setDialogTitle(Locale.get("JOptionPane.OweWindow.saveButton.title.wrong"));
							setDialogMessage(Locale.get("JOptionPane.OweWindow.saveButton.message.wrong"));

							Object[] options = {Locale.get("JOptionPane.Ok")};
							JOptionPane.showOptionDialog(OweWindow.getInstance(),
									getDialogMessage(),
									getDialogTitle(),
									JOptionPane.OK_OPTION,
									JOptionPane.INFORMATION_MESSAGE,
									null,
									options,
									options[0]);
							saveOk = false;
							break;
						}

					}

					if (saveOk) {
						setDialogTitle(Locale.get("JOptionPane.OweWindow.saveButton.title.ok"));
						setDialogMessage(Locale.get("JOptionPane.OweWindow.saveButton.message.ok"));

						Object[] options = {Locale.get("JOptionPane.Ok")};
						JOptionPane.showOptionDialog(OweWindow.getInstance(),
								getDialogMessage(),
								getDialogTitle(),
								JOptionPane.OK_OPTION,
								JOptionPane.INFORMATION_MESSAGE,
								null,
								options,
								options[0]);						
					}

				}

			});

		}
		return saveButton;
	}

	/**
	 * This method initializes exitButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (exitButton == null) {
			exitButton = new JButton();
			exitButton.setBounds(new Rectangle(750, 613, 77, 17));
			exitButton.setText(Locale.get("OweWindow.exitButton"));
			exitButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					(OweWindow.getInstance()).dispose();
					oweWindow = null;

				}
			});

		}
		return exitButton;
	}

	private boolean checkRowValues(int row) {

		boolean validRoom = false;
		boolean validParticular = false;
		boolean validConcept = false;
		boolean validPrice = false;
		boolean validVat = false;
		boolean validAmount = false;
		boolean validRow = false;

		try {

			Vector rooms = RoomController.roomList();

			for (int i=0; i<rooms.size();i++) {
				if (((TextItem)rooms.elementAt(i)).getId() .equals( ((TextItem) getOwesTable().getValueAt(row, 1)).getId() )) { 
					validRoom = true;
					break;
				}

			}			

			Vector particulars = ParticularController.particularList();

			for (int i=0; i<particulars.size();i++) {
				if (((TextItem)particulars.elementAt(i)).getId() .equals( ((TextItem) getOwesTable().getValueAt(row, 2)).getId() )) { 
					validParticular = true;
					break;
				}

			}			

			Vector concepts = ConceptController.conceptList();

			for (int i=0; i<concepts.size();i++) {
				if (((TextItem)concepts.elementAt(i)).getId() .equals( ((TextItem) getOwesTable().getValueAt(row, 3)).getId() )) { 
					validConcept = true;
					break;
				}

			}			

			try {
				new BigDecimal((String) getOwesTable().getValueAt(row, 4).toString());
				validPrice = true;
			} catch (NullPointerException e) {
				validPrice = false;
			}

			try {
				new BigDecimal((String) getOwesTable().getValueAt(row, 5).toString());
				validVat = true;
			} catch (NullPointerException e) {
				validVat = false;
			}

			try {
				new BigDecimal((String) getOwesTable().getValueAt(row, 6).toString());
				validAmount = true;
			} catch (NullPointerException e) {
				validAmount = false;
			}

			validRow = validRoom && validParticular && validConcept && validPrice && validVat && validAmount;

		} catch (NullPointerException e) {
			validRow = false;
		}

		return validRow;

	}

	/*	private boolean inputErrors() {		

		if (!ErrorsHandler.getErrors().isEmpty()) {

			if (ErrorsHandler.getErrorAt(0).getItem().equals("roomUnaceptable")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("OweWindow.errors.roomUnaceptable")+ "</html>");

				getOwesTable().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("invoice")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("OweWindow.errors.invoice")+ "</html>");

				getOwesTable().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("concept")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("OweWindow.errors.concept")+ "</html>");
				getOwesTable().setBorder(new LineBorder(Color.red, 2));	
				Toolkit.getDefaultToolkit().beep();
				return true;
			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("particular")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("OweWindow.errors.particular")+ "</html>");

				getOwesTable().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

			if (ErrorsHandler.getErrorAt(0).getItem().equals("roomNotBusy")) {
				getInfoPanel().setErrorText("<html>" + Locale.get("InfoPanel.errors.title") + "<br>" 
						+ Locale.get("OweWindow.errors.roomNotBusy")+ "</html>");

				getOwesTable().setBorder(new LineBorder(Color.red, 2));
				Toolkit.getDefaultToolkit().beep();
				return true;

			}

		}

		return false;

	}*/

}  //  @jve:decl-index=0:visual-constraint="10,10"
